#include <stdio.h>
#include <string.h>
#include "freertos/FreeRTOS.h"
#include "freertos/semphr.h"
#include "freertos/ringbuf.h"
#include "freertos/queue.h"
#include "./uhci.h"
#include "driver/periph_ctrl.h"
#include "driver/uart.h"
#include "rom/cache.h"

uint8_t buf[50] = "example\n";

static void uart_init(void)
{
    uart_config_t uart_config = {
       .baud_rate = 115200,
       .data_bits = UART_DATA_8_BITS,
       .parity = UART_PARITY_DISABLE,
       .stop_bits = UART_STOP_BITS_1,
       .flow_ctrl = UART_HW_FLOWCTRL_RTS,
       .rx_flow_ctrl_thresh = 100,
    };
    uart_param_config(UART_NUM_0, &uart_config);
}


void app_main()
{
    uhci_event_t event;
    QueueHandle_t uhci_queue = NULL;
    uhci_config_t cfg = {
        .uhci_num  = UHCI_NUM_0,
        .uart_num = 0,
        .rx_time_out = 16,
        .tx_time_out = 16,
        .intr_mask = UHCI_OUT_EOF | UHCI_OUT_DONE | UHCI_IN_DONE | UHCI_RX_HUNG | UHCI_TX_HUNG, 
    };

    uart_init();
    uhci_config(&cfg);
    uhci_driver_install(UHCI_NUM_0, &uhci_queue, 10, 0);
    uhci_intr_enable(UHCI_NUM_0, UHCI_OUT_EOF | UHCI_OUT_DONE | UHCI_IN_DONE |  UHCI_RX_HUNG | UHCI_TX_HUNG);
    while(1) {

        /* read test */
        // memset(buf, 0, 20);
        // if (xQueueReceive(uhci_queue, (void * )&event, (portTickType)portMAX_DELAY)) {
        //   uhci_read_data(UHCI_NUM_0, buf, 7);
        //   printf("%s\n", buf);
        // }
        
      /* write test */
        uhci_write_data(UHCI_NUM_0, buf, 8);
        vTaskDelay(1000/portTICK_RATE_MS);
    }
}
